Attribute VB_Name = "Module1"
Option Explicit




' rutina que carga los datos al treeview1 desde un archivo de texto
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


Sub Cargar_Treeview(ByVal Path As String, _
                    ByVal TreeView As TreeView)

Dim ArrayNodos() As Node ' array de nodos
Dim Linea As String
Dim Nivel As Integer

Dim nNodos As Integer
Dim i As Integer ' para las imagenes

    ' abre el archivo de texto
    Open Path For Input As #1
    
    With TreeView
    
        .Nodes.Clear ' limpia el TV
        .ImageList = Form1.ImageList1
        .HotTracking = True
    
        ' recorre el fichero linea por linea hasta el final
        Do While Not EOF(1)
            ' lee la linea actual
            Line Input #1, Linea
            ' resetea  y pone el nivel en 1
            Nivel = 1
        
            ' averigua el nivel de estalinea ( cuantos tabuladores tiene )
            Do While Left$(Linea, 1) = vbTab
                Nivel = Nivel + 1 ' incrementa el nivel
                Linea = Mid$(Linea, 2)
            Loop

            ' esto se ejecuta cuando cambia el nivel, si es el mismo lo ignora
            If Nivel > nNodos Then
                nNodos = Nivel
                ' redimensiona el array
                ReDim Preserve ArrayNodos(1 To nNodos)
            End If
        
            ' Aade los nodos
            '''''''''''''''''''''''''
        
            ' nodo principal de nvel 1
            If Nivel = 1 Then
                i = i + 1
                Set ArrayNodos(Nivel) = .Nodes.Add(, , , Linea, i)
            
            ' nodos hijos
            Else
            
                Set ArrayNodos(Nivel) = .Nodes.Add(ArrayNodos(Nivel - 1), _
                                                   tvwChild, , Linea, 3)
                ' expande
                'ArrayNodos(Nivel).EnsureVisible
            End If
        Loop
    End With
    'cierra
    Close
End Sub




Sub CopiarTreeView( _
    treeOrigen As TreeView, _
    treeDestino As TreeView)

    Dim nodeRoot As Node
    ' eliminar todos los nodos
    treeDestino.Nodes.Clear
    
    ' Asocia el ImageList al Treeview destino
    If Not treeOrigen.ImageList Is Nothing Then
       Set treeDestino.ImageList = treeOrigen.ImageList
    End If
    
    'Recorrer todos los nodos para copiar todo el contenido
       For Each nodeRoot In treeOrigen.Nodes
           If (nodeRoot.Parent Is Nothing) Then
                Call CopyTVParentNode(nodeRoot, treeDestino.Nodes)
           End If
        Next
End Sub

Private Sub CopyTVParentNode(nodeParent As Node, nodesDest As Nodes)
Dim nodeDummy As Node
Dim nodeChild As Node

    Set nodeDummy = CopyNode(nodeParent, nodesDest)
    Set nodeChild = nodeParent.Child
    Do While Not (nodeChild Is Nothing)
        If nodeChild.Children Then
            Call CopyTVParentNode(nodeChild, nodesDest)
        Else
            Set nodeDummy = CopyNode(nodeChild, nodesDest)
        End If
        Set nodeChild = nodeChild.Next
    Loop
End Sub


Private Function CopyNode(nodeSrc As Node, nodesDest As Nodes) As Node
    
    With nodeSrc
        If (.Parent Is Nothing) Then
            Set CopyNode = nodesDest.Add(, , .Key, .Text, .Image, .SelectedImage)
        Else
            Set CopyNode = nodesDest.Add(.Parent.Index, _
            tvwChild, .Key, .Text, .Image, .SelectedImage)
        End If
    End With
End Function
